#
#     26 Oct 96   for da adopted from charissa version
#    8 jan 98   modified for use with F2VB module

# May 2000 -  Silena 4418 DA
#    Now a common version for all uses of D2VB/F2VB module


set debug 0
set started 0

set frame SYS
set icontitle  "SysCntl"

set OS "Unknown"

if {![info exists UCL]} then {set UCL 0}

if {![info exists CAMACPresent]} then {set CAMACPresent 0}
if {![info exists VMEPresent]} then {set VMEPresent 0}
if {![info exists VXIPresent]} then {set VXIPresent 0}

if {![info exists CAMACEnable]} then {set CAMACEnable 0}
if {![info exists VMEEnable]} then {set VMEEnable 0}
if {![info exists VXIEnable]} then {set VXIEnable 0}

if {![info exists TSPresent]} then {set TSPresent 1}
if {![info exists EBPresent]} then {set EBPresent 0}

if {![info exists TSEnable]} then {set TSEnable 0}
set tapestate -1
set tapeassoc ""

set X2VBPresent 1

if {![info exists RDOUTEnable]} then {set RDOUTEnable 1}

if {![info exists histPresent]} then {set histPresent 1}
if {![info exists histEnable]} then {set histEnable 1}
if {![info exists HistMode]} then {set HistMode 1}

if {![info exists txEnable]} then {set txEnable 0}
if {![info exists ebtxEnable]} then {set ebtxEnable 0}

if {[info exists env(CamacServer)]} then {set resource $env(CamacServer)} else {set resource camac}
set CAMACserver $resource

if {[info exists env(VMEServer)]} then {set resource $env(VMEServer)} else {set resource vme}
set VMEserver $resource

if {[info exists env(VXIServer)]} then {set resource $env(VXIServer)} else {set resource VXI}
set VXIserver $resource

if {[info exists env(CamacController)]} then {set resource $env(CamacController)} else {set resource SCC}
set CAMACcontroller $resource

if {[info exists env(RDOUThdwre)] == 0} then {set hdwre F2VB} else {set hdwre $env(RDOUThdwre)}
set RDOUThdwre $hdwre

if {[info exists env(RDOUTserver)]} then {set resource $env(RDOUTserver)} else {set resource vme}
set RDOUTserver $resource

if {![info exists RDOUTserverList]} then {set RDOUTserverList $RDOUTserver}

#    Note - all use of the common register access procedures are for the ReadOut server
set RegisterServer $RDOUTserver

if {[info exists env(SHistServer)]} then {set resource $env(SHistServer)} else {set resource VMEhist}
set SpectrumServer $resource

if {![info exists SpectrumserverList]} then {set SpectrumserverList $SpectrumServer}

if {![info exists CheckDAPeriod]} then {set CheckDAPeriod 5}

set vxistate 0
set vmestate 0
set camacstate 0
set tapestate 0
set readoutstate 0

set ScalerType LC2551

set S9418_Base 1
set V767_Base 16
set V890_Base 24
set V785_Base 32

set RDOUTstate 0
set MaxTries 20

set Alive -1

#    default setup message is for FERA systems which use CAMAC

set SetupMessage "\n\
Are you sure you wish to SETUP the data acquisition system?\n\n\
SETUP will STOP data acquisition.\n\
Configure the CAMAC Control software and restore CAMAC parameter settings.\n\
It will also recreate all histograms selected.\n\
This may take several minutes.\n\n\
If you decide to continue please wait for the SETUP sequence to complete and DO NOT touch the system while it is in progress.
"

set TestBuffer ""

#    list of menu items and associated actions for the ACTIONS menu button 

set actionlist {                                             \
   {"Create GUI Registers"              "make-registers"}    \
   {"Configuration/Test/Debug Frame"    "make-test-frame"}   \
   {"Load Acquisition Options"          "Set_Options"}       \
   {"Save Acquisition Options"          "update_Options"}    \
   {"Enable DA System tracing"          "click-trace 1"}     \
   {"Disable DA System tracing"         "click-trace 0"}     \
   {"transferTxStatus"                  "click-special 1"}   \
   {"transferTxReset"                   "click-special 2"}   \
   {"transferInit"                      "click-special 3"}   \
   {"Start test task"                   "click-testmode 0"}  \
   {"End test task"                     "click-testmode 1"}  \
   {"Show EXEC task ID"                 "click-ID"}          \
   {"Release all spectra"               "unmap_spectra"}     \
   {"Map all spectra"                   "map_spectra"}       \
   {"toggle readout pause state"        "click-special 7"}   \
}

#    list of registers required by the GUI

set registerlist { 
   {EXEC.Sig1                sigTask  "-tEXEC -sUSR1"} \
   {EXEC.Sig2                sigTask  "-tEXEC -sUSR2"} \
   {EXEC.Action              generic  "-nEXEC_Action -tint"} \
   {EXEC.Parameter           generic  "-nEXEC_Parameter -tstring"} \
   {EXEC.ID                  generic  "-nEXEC_ID -tstring"} \
   {TS_Server                generic  "-nTS_Server -tstring"} \
   {TS_Port                  generic  "-nTS_Port -tint"} \
   {Xfer_Option              generic  "-nXfer_Option -tint"} \
   {Format_Option            generic  "-nFormat_Option -tint"} \
   {EB_Server                generic  "-nEB_Server -tstring"} \
   {EB_Port                  generic  "-nEB_Port -tint"} \
   {EBXfer_Option            generic  "-nEBXfer_Option -tint"} \
   {RawDataStorage           generic  "-nRawDataStorage -tstring"} \
}

if {$RDOUThdwre == "VME"} {
   lappend registerlist [list EXEC.Response  generic  "-nEXEC_Response -tblock -ayes -i200 -l444 -fx"]
}

if {$VERSION == "MIDAS"} {
   lappend registerlist [list TDC.Mode             generic  "-nTDC_Mode -tint"]
   lappend registerlist [list TDC.Option           generic  "-nTDC_Option -tint"]
}

lappend registerlist [list $RDOUThdwre.CAlive              generic  "-nDACQ_Alive -tint"]
lappend registerlist [list $RDOUThdwre.Ctxenable           generic  "-nDACQ_TxEnable -tint"]
lappend registerlist [list $RDOUThdwre.Cebtxenable         generic  "-nDACQ_EBTxEnable -tint"]
lappend registerlist [list $RDOUThdwre.Crdoutenable        generic  "-nDACQ_RdOutEnable -tint"]
lappend registerlist [list $RDOUThdwre.Chistenable         generic  "-nDACQ_HistEnable -tint"]
lappend registerlist [list $RDOUThdwre.Chistmode           generic  "-nDACQ_HistMode -tint"]
lappend registerlist [list $RDOUThdwre.Cspectramapped      generic  "-nDACQ_SpectraMapped -tint"]
lappend registerlist [list $RDOUThdwre.Ctrace              generic  "-nDACQ_Trace -tint"]
lappend registerlist [list $RDOUThdwre.Sstate              generic  "-nDACQ_State -tint"]
lappend registerlist [list $RDOUThdwre.TestMode            generic  "-nDACQ_TestMode -tint"]
lappend registerlist [list $RDOUThdwre.DebugMode1          generic  "-nDACQ_DebugMode1 -tint"]
lappend registerlist [list $RDOUThdwre.DebugMode2          generic  "-nDACQ_DebugMode2 -tint"]
lappend registerlist [list $RDOUThdwre.DelayTicks          generic  "-nDACQ_DelayTicks -tint"]
lappend registerlist [list $RDOUThdwre.PollTicks           generic  "-nDACQ_PollTicks -tint"]
lappend registerlist [list $RDOUThdwre.StatsTime           generic  "-nDACQ_StatsTime -tint"]
lappend registerlist [list $RDOUThdwre.Stats               generic  "-nDACQ_Stats -tint -ayes -i0"]
lappend registerlist [list $RDOUThdwre.Rates               generic  "-nDACQ_Rates -tint -ayes -i0"]

if {$RDOUThdwre == "D2VB" || $RDOUThdwre == "F2VB"} {

if {$RDOUThdwre == "D2VB"} {
lappend registerlist [list NumVXICrates     generic  "-nNumVXICrates -tint"]
lappend registerlist [list CrateMap         generic  "-nCrateMap -tint"]
lappend registerlist [list TitrisPresent    generic  "-nTitrisPresent -tint"]
lappend registerlist [list TimeFilter       generic  "-nTimeFilter -tint"]
}

lappend actionlist [list "Start RAW Data Storage" "StartRawDataStorage"]
lappend actionlist [list "Stop RAW Data Storage"  "click-special 9"]


proc StartRawDataStorage {} {
    write-register RawDataStorage "/rootfs/tmp/X2VBRawData"
    click-special 8
}

}

if {$VERSION == "GREAT"} {
lappend registerlist [list $RDOUThdwre.OutputAll    generic  "-nMerge_OutputAll -tint"]

lappend actionlist [list "All Data goes to tape"  "write-register $RDOUThdwre.OutputAll 1"]
lappend actionlist [list "Good Data only to tape" "write-register $RDOUThdwre.OutputAll 0"]
}

proc Set_Options {} {
    global Options

    load_Options

    Set_Common_Options
    Set_S9418_Options
    Set_V785_Options
    Set_V890_Options
    Set_V767_Options

    update_Options
}

proc Set_Common_Options {} {

    load_Options

   if {![info exists Options(Stat.channels)]} {set Options(Stat.channels) 4096}
   if {![info exists Options(Rate.channels)]} {set Options(Rate.channels) 4096}

    update_Options

}

proc Set_S9418_Options {} {
    global Options S9418_Base

    load_Options

   if {![info exists Options(s9418.channels)]} {set Options(s9418.channels) 4096}
   if {![info exists Options(s9418.offset)]} {set Options(s9418.offset) 0}
   if {![info exists Options(s9418.shift)]} {set Options(s9418.shift) 0}
   if {![info exists Options(s9418_GroupBase)]} {set Options(s9418_GroupBase) $S9418_Base}
   set S9418_Base  $Options(s9418_GroupBase)

    update_Options
}

proc Set_V785_Options {} {
    global Options V785_Base

    load_Options

   if {![info exists Options(v785.channels)]} {set Options(v785.channels) 4096}
   if {![info exists Options(v785.offset)]} {set Options(v785.offset) 0}
   if {![info exists Options(v785.shift)]} {set Options(v785.shift) 0}
   if {![info exists Options(v785_GroupBase)]} {set Options(v785_GroupBase) $V785_Base}
   set V785_Base   $Options(v785_GroupBase)

    update_Options
}

proc Set_V890_Options {} {
    global Options V890_Base

    load_Options

   if {![info exists Options(v890.channels)]} {set Options(v890.channels) 4096}
   if {![info exists Options(v890.offset)]} {set Options(v890.offset) 0}
   if {![info exists Options(v890.shift)]} {set Options(v890.shift) 1}
   if {![info exists Options(v890_GroupBase)]} {set Options(v890_GroupBase) $V890_Base}
   set V890_Base   $Options(v890_GroupBase)

   if {![info exists Options(v890.acqmode)]} {set Options(v890.acqmode) 0}
   if {![info exists Options(v890.windowwidth)]} {set Options(v890.windowwidth) 160}
   if {![info exists Options(v890.windowoffset)]} {set Options(v890.windowoffset) -150}

    update_Options
}

proc Set_V767_Options {} {
    global Options V767_Base

    load_Options

   if {![info exists Options(v767.channels)]} {set Options(v767.channels) 4096}
   if {![info exists Options(v767.offset)]} {set Options(v767.offset) 0}
   if {![info exists Options(v767.shift)]} {set Options(v767.shift) 4}
   if {![info exists Options(v767_GroupBase)]} {set Options(v767_GroupBase) $V767_Base}
   set V767_Base   $Options(v767_GroupBase)

   if {![info exists Options(v767.acqmode)]} {set Options(v767.acqmode) 0}
   if {![info exists Options(v767.windowwidth)]} {set Options(v767.windowwidth) 300}
   if {![info exists Options(v767.windowoffset)]} {set Options(v767.windowoffset) -250}

    update_Options
}

proc Dump_Raw_VME_Data {} {

   set data ""

   set maxmodule [inform vmecontrol inquire s9418count]
   if {[string length $maxmodule] > 2} {set maxmodule 0}
   for {set i 1} {$i <= $maxmodule} {incr i} {
      append data "S9418#$i\n"
      execute-command 19 "Getting Raw Data for S9418#$i" "2 $i" 2
      append data [read-register EXEC.Response]
      append data "\n"
   }

   set maxmodule [inform vmecontrol inquire v767count]
   if {[string length $maxmodule] > 2} {set maxmodule 0}
   for {set i 1} {$i <= $maxmodule} {incr i} {
      append data "V767#$i\n"
      execute-command 19 "Getting Raw Data for V767#$i" "1 $i" 2
      append data [read-register EXEC.Response]
      append data "\n"
   }

   set maxmodule [inform vmecontrol inquire v785count]
   if {[string length $maxmodule] > 2} {set maxmodule 0}
   for {set i 1} {$i <= $maxmodule} {incr i} {
      append data "V785#$i\n"
      execute-command 19 "Getting Raw Data for V785#$i" "1 $i" 2
      append data [read-register EXEC.Response]
      append data "\n"
   }

   set maxmodule [inform vmecontrol inquire v890count]
   if {[string length $maxmodule] > 2} {set maxmodule 0}
   for {set i 1} {$i <= $maxmodule} {incr i} {
      append data "V890#$i\n"
      execute-command 19 "Getting Raw Data for V890#$i" "1 $i" 2
      append data [read-register EXEC.Response]
      append data "\n"
   }

   midas-information "$data"
}

proc write-register {r v} {
    global RDOUTserverList

    foreach server $RDOUTserverList {
        EG "register :name '/$server/$r' :value '$v'"
    }
}

proc read-register {r} {
    global RDOUTserverList

    foreach server $RDOUTserverList {
        set vl [EG "register :name '/$server/$r' ?value"]
    }
    return $vl
}

proc execute-command {args} {
    global RDOUTserver RDOUTserverList

#    first      action
#    second     message
#    third      parameter
#    fourth     signal number

    foreach server $RDOUTserverList {
        if {[llength $args] > 2} {EG "register :name '/$server/EXEC.Parameter' :value '[third $args]'"}
        EG "register :name '/$server/EXEC.Action' :value '[first $args]'"
        if {[llength $args] > 3} {
            EG "register :name '/$server/EXEC.Sig[fourth $args]' :value '0'"
        } else {
            EG "register :name '/$server/EXEC.Sig1' :value '0'"
        }
        set RDOUTserver $server
        if {[llength $args] > 1} {wait_for_completion "[second $args]"} else {wait_for_completion ""}
    }
}

proc wait_for_completion {args} {
    global RDOUTserver MaxTries EGreport

    set tries 1
    set TASK EXEC

    while {$tries < $MaxTries} {

        if {[llength $args] == 0} then {
            if {$EGreport != -1} then {set-footer "$RDOUTserver: Waiting for action to complete ($tries)"}
        } else {
            if {[llength $args] > 1} then {
                set TASK [first $args]
                if {$EGreport != -1} then {set-footer "$RDOUTserver: [second $args] ($tries)"}
            } else {
                if {$EGreport != -1} then {set-footer "$RDOUTserver: [first $args] ($tries)"}
            }
        }

        set z [catch {EG "register :name '/$RDOUTserver/$TASK.Action' ?value"} m ]

        if {$z != 0} then {
            midas-warning "$RDOUTserver: Unable to confirm state of action\n$m"
            clear-footer
            return 1
        }

        if {$m == 0} then {
            if {$EGreport != -1} clear-footer
            return 0
        }
        incr tries
        after 500
    }

    midas-warning "$RDOUTserver: Action has not completed\nGiving up waiting"
    clear-footer
    return 1
}

proc make-registers {} {
    global registerlist RegisterServer RDOUTserverList
    global EGreport VERSION

    set EGreport_SAVE $EGreport
    set EGreport -1
    set-footer "defining registers"

    foreach server $RDOUTserverList {
        set RegisterServer $server
        foreach item $registerlist {
            define-register [second $item] [lindex $item 0] "[third $item]"
        }
    }

    clear-footer
    set EGreport $EGreport_SAVE
}

proc starttask {task} {
#    Check if it is necessary to pre-start server interface task

    set started [inform $task inquire started]
    if {$started == 0} then {
       send $task start
       send $task close-frame
       after 2000
    }
}

proc click-tapes {action} {
   global TSEnable

   if {$TSEnable == 0} then {redisplay-tapes; return}

   starttask tape

#    set tape server state

   send tape click-egstate $action
   redisplay-tapes
   update_button_states
}

proc redisplay-tapes {} {
   global TSEnable tapestate tapeassoc

   if {$TSEnable == 0} then {:modify TAPE :value -1; return}

   set-busy
   starttask tape
  
#    find tape server state

   catch {set tapestate [send tape read-egstate]}
   :modify TAPE :value $tapestate

#    find run number

   catch {set run [fifth [send tape inquire-ganil-status]]}
   :modify RUN :value $run

#    find data stream association

   catch {set tapeassoc [send tape find-assoc-strings 1]}
   :modify STREAM :value "$tapeassoc"

   catch {send tape update-information}

   if {$tapestate == 0} then {
       set rate 0
   } else {
       catch {set rate [first [send tape inquire taperates]]}
   }
   :modify RATE :value $rate

   catch {:modify PERCENT :value [string range [inform tape inquire tapepercent] 0 3]}

   clear-busy
}
  
proc click-da {v} {
        global debug env VERSION RDOUTstate RDOUThdwre RDOUTEnable TSEnable CAMACEnable VMEEnable VXIEnable
        if {$debug} then {puts stderr "setting MIDAS DA to state $v"}

    Custom_PreCheck $v

#    First check that the servers have been configured - that is registers for the installed hardware have been created
#    This is performed when the server is installed for VXI

    if {$VMEEnable != 0 && [inform vmecontrol HasBeenConfigured] == 0} then {
         midas-warning "The VME server has not been configured\nIt may recently have been restarted\nUse SETUP first"
         return -1
    }

    if {$CAMACEnable != 0 && [inform camaccontrol HasBeenConfigured] == 0} then {
         midas-warning "The CAMAC server has not been configured\nIt may recently have been restarted\nUse SETUP first"
         return -1
    }

#    Now if the action is GO ensure that a parameter restore has been performed

    if {$v == 1} {

    if {$CAMACEnable != 0 && [inform camacsaverestore HasBeenRestored] == 0} then {
         set r [midas-confirmation "You have not performed a parameter restore for the CAMAC server\nIt may recently have been restarted\n\
                          Do you wish to continue or to abort so that you can SETUP first"]
         if {$r == 0} then {return -1}
    }

    if {$VMEEnable != 0 && [inform vmesaverestore HasBeenRestored] == 0} then {
         set r [midas-confirmation "You have not performed a parameter restore for the VME server\nIt may recently have been restarted\n\
                          Do you wish to continue or to abort so that you can SETUP first"]
         if {$r == 0} then {return -1}
    }

    if {$VXIEnable != 0 && [inform vxicontrol VXI-ResetState] == 0} then {
         set r [midas-confirmation "The VXI control software has NOT performed a software reset\n\
               for one or more VXI servers\nIt may recently have been restarted\n\
               Your VXI hardware may not operate correctly unless this is done.\n\
               Do you wish to continue or to abort so that you can SETUP first"]
         if {$r == 0} then {return -1}
    }

    if {$VXIEnable != 0 && [inform vxicontrol VXI-RestoreState] == 0} then {
         set r [midas-confirmation "You have not performed a parameter restore for one or more VXI servers\nIt may recently have been restarted\n\
                          Do you wish to continue or to abort so that you can SETUP first"]
         if {$r == 0} then {return -1}
    }

    }

     Custom_PostCheck $v

     if {$RDOUTEnable != 0} then {set RDOUTstate $v}

    set z [catch {
        if {$v==0} then {
            set-footer "STOPping MIDAS DA [date]"
                Custom_PreStop
                Stop_Electronics
                click-vxi 0
                click-camac 0
                click-vme 0
                click-rdout 0
                click-tapes 0
                Custom_PostStop
            set-footer "MIDAS DA STOPped [date]"
            insert-log "sys: [date] Data Acquisition STOPPED"
         }
         if {$v==1} then {
            set-footer "GOing MIDAS DA [date]"
                Custom_PreGo
                if {$RDOUTEnable != 0} then {
                    set state [read-register $RDOUThdwre.Sstate]
                    if {$state == 2} then {
                        midas-warning "Data Acquisition is already running - Use STOP first"
                        clear-footer
                        return -1
                    }
                }
                if {$TSEnable != 0} then {
                    if {[send tape read-storagestate] != 0} then {
                         set r [midas-confirmation "Tape Server is in No Storage state\n\
                                Do you wish to continue or to abort so that you can change this"]
                         if {$r == 0} then {return -1}
                    }
                    click-tapes 1
                    if {[send tape read-egstate] != 1} then {
                         set r [midas-confirmation "Tape Server not in Going state\n\
                                Do you wish to continue or to abort so that you can correct the problem"]
                         if {$r == 0} then {return -1}
                    }
                }
                Reset_Electronics
                if {$VERSION == "GRT4P"} then {click-vme 2}
                if {$RDOUTEnable != 0} then {
                    click-rdout 3
                    click-rdout 1
                    if {[read-register $RDOUThdwre.Sstate] != 2} then {
                         midas-warning "Data Acquisition Program not in Going state\n\GO aborted"
                         return -1
                    }
                }
                click-vme 1
                click-camac 1
                click-vxi 1
                Go_Electronics
                Custom_PostGo
            set-footer "MIDAS DA GOing [date]"
            insert-log "sys: [date] Data Acquisition GOING"
         }
     } m ]

   set footertext $env(FooterText)
   click-redisplay
   set-footer $footertext

    return [da_state]
}

if {$UCL == 1} then {proc do-runtime {w v} {}}

#    the following three procedures are available for applications to perform the critical DA hardware control
proc Stop_Electronics {} {}
proc Go_Electronics {} {}
proc Reset_Electronics {} {}

#    the following ten procedures are available for applications to perform specific actions during the general control sequences 
proc Custom_PreCheck {opt} {}    ;# opt = 0 STOP,  opt = 1 GO,  opt = 2 SETUP
proc Custom_PostCheck {opt} {}
proc Custom_PreStop {} {}
proc Custom_PostStop {} {}
proc Custom_PreGo {} {}
proc Custom_PostGo {} {}
proc Custom_PreSetup {opt} {}  ;#  opt = 0 setup where needed,  opt = 1  setup everything,  opt = 2  prompt
proc Custom_SetupA {opt} {}    ;#  opt = 0 setup where needed,  opt = 1  setup everything,  opt = 2  prompt
proc Custom_SetupB {opt} {}    ;#  opt = 0 setup where needed,  opt = 1  setup everything,  opt = 2  prompt
proc Custom_SetupC {opt} {}    ;#  opt = 0 setup where needed,  opt = 1  setup everything,  opt = 2  prompt
proc Custom_SetupD {opt} {}    ;#  opt = 0 setup where needed,  opt = 1  setup everything,  opt = 2  prompt
proc Custom_PostSetup {opt} {}
proc Custom_Redisplay {} {}
proc Custom_Start {} {}

proc click-setup {arg} {
    global CAMACEnable CAMACserver CAMACcontroller VMEEnable VXIEnable VXIserver RDOUThdwre RDOUTEnable
    global histPresent txEnable ebtxEnable histEnable
    global SetupMessage

    make-registers

    click-histenable $histEnable

    click-txenable $txEnable
    click-ebtxenable $ebtxEnable


    if {$arg == 0} then {

#    allow the user to chicken out!

        set z [catch {midas_dialog [self frame-name].confirmDialog "Confirmation Request for Data Acquisition SETUP" \
           "$SetupMessage" "" 1 "Cancel" "Setup where needed" "Setup everything" "Prompt me"} m]
        if {$z != 0} then {
           puts stderr "midas-warning: [self frame-name].confirmDialog: $m"
           destroy [self frame-name].confirmDialog
           return 0
        }

        if {$m == 0} then {return}
        set opt [expr $m - 1]

    } else {
        set opt 0
    }

    Custom_PreCheck 2

   if {$CAMACEnable != 0} then {

        do_inhibit_camac

    if {[inform camaccontrol Configuration] == ""}    then {inform camacsaverestore click-CSRrestore-current}
    if {[inform camaccontrol Configuration] == ""} then {
        midas-warning "CAMAC server is not correctly configured\nPlease correct this and retry SETUP"
        return
    }

    if {[inform camaccontrol HasBeenConfigured] == 0} then {inform camaccontrol load-configuration}
    if {[inform camaccontrol HasBeenConfigured] == 0} then {
        midas-warning "CAMAC server is not correctly configured\nPlease correct this and retry SETUP"
        return
    }
  }

  if {$VMEEnable != 0} then {

#    load VME configuration and create registers
    if {[inform vmecontrol Configuration] == ""}    then {inform vmesaverestore click-CSRrestore-current}
    if {[inform vmecontrol Configuration] == ""} then {
        midas-warning "VME server is not correctly configured\nPlease correct this and retry SETUP"
        return
    }

    if {[inform vmecontrol HasBeenConfigured] == 0} then {inform vmecontrol Configure}
    if {[inform vmecontrol HasBeenConfigured] == 0} then {
        midas-warning "VME server is not correctly configured\nPlease correct this and retry SETUP"
        return
    }
  }

  if {$VXIEnable != 0} then {
     if {$opt != 2} then {
        if {[inform vxicontrol inquire VXIconfigured] == 0} then {inform vxicontrol "configure-all  1"}
     } else {
        if {[inform vxicontrol inquire VXIconfigured] != 0} then {
            set r [midas-confirmation "The VXI control software has already been configured and so this does not need to be repeated.\n\
               However if you have recently made changes to the VXI hardware installed the VXI control software should probe the hardware \
               to update its configuration information." \
               "Probe for VXI hardware changes?"  "Skip to next step (recommended)"]
            if {$r == 0} then {inform vxicontrol "configure-all  1"}
        } else {
            set r [midas-confirmation "The VXI control software has NOT been configured and so is uncertain about your VXI hardware.\n\
               The VXI control software should probe the hardware to obtain the configuration information." \
               "Probe for VXI hardware changes? (recommended)"  "Skip to next step"]
            if {$r == 0} then {inform vxicontrol "configure-all  1"}
        }
     }
  }

#    check DA program installed
     if {[checkinstallation] != 0} then {return}

    Custom_PostCheck 2

#    stopping DA
    click-da 0

     Custom_PreSetup $opt

#    setup readout software
    click-rdout 2

   if {$CAMACEnable != 0} then {

#    reset camac hardware
    click-camac 2

#   restore CAMAC parameters
     if {[inform camacsaverestore HasBeenRestored] == 0 || $opt != 0} then {inform camacsaverestore click-SSRrestore-current}
     if {[inform camacsaverestore HasBeenRestored] == 0} then {
        midas-warning "CAMAC parameter restore has not been successful\nYou may need to correct this and retry SETUP"
     }
   }

     Custom_SetupA $opt

   if {$VMEEnable != 0} then {

#    reset VME hardware
    click-vme 2

#   setup VME hardware and restore VME parameters
     if {[inform vmesaverestore HasBeenRestored] == 0 || $opt != 0} then {
         click-vme 3
         inform vmesaverestore click-SSRrestore-current
     }
     if {[inform vmesaverestore HasBeenRestored] == 0} then {
        midas-warning "VME parameter restore has not been successful\nYou may need to correct this and retry SETUP"
     }
   }

     Custom_SetupB $opt

   if {$VXIEnable != 0} then {

#   reset VXI

     if {$opt != 2} then {
        if {[inform vxicontrol VXI-ResetState] == 0 || $opt != 0} then {inform vxicontrol DAQ-reset}
     } else {
        if {[inform vxicontrol VXI-ResetState] != 0} then {
            set r [midas-confirmation "The VXI control software has already performed a software reset and so this does not need to be repeated.\n\
               You may repeat the software reset if you wish but this may cause VXI module setup information to be lost." \
               "Perform software reset?"  "Skip to next step (recommended)"]
            if {$r == 0} then {click-vxi 3}
        } else {
            set r [midas-confirmation "The VXI control software has NOT performed a software reset.\n\
               Your VXI hardware may not operate correctly unless this is done." \
               "Perform software reset? (recommended)"  "Skip to next step"]
            if {$r == 0} then {click-vxi 3}
        }
     }

     if {[inform vxicontrol VXI-ResetState] == 0} then {
         midas-warning "VXI software reset has not been successful\nYou may need to correct this and retry SETUP"
     }

     Custom_SetupC $opt

#    setup VXI hardware

     if {$opt != 2} then {
        if {[inform vxicontrol VXI-SetupState] == 0 || $opt == 1} then {click-vxi 4} else {click-vxi 4 1}
     } else {
        if {[inform vxicontrol VXI-SetupState] != 0} then {
            set r [midas-confirmation "The VXI control software has already performed a software setup and so this does not need to be repeated.\n\
               You may repeat the software setup if you wish but this may cause VXI module setup information to be lost." \
               "Perform software setup?"  "Skip to next step (recommended)"]
            if {$r == 0} then {click-vxi 4}
        } else {
            set r [midas-confirmation "The VXI control software has NOT performed a software setup.\n\
               Your VXI hardware may not operate correctly unless this is done." \
               "Perform software setup? (recommended)"  "Skip to next step"]
            if {$r == 0} then {click-vxi 4}
        }
     }

     if {[inform vxicontrol VXI-SetupState] == 0} then {
         midas-warning "VXI software setup has not been successful\nYou may need to correct this and retry SETUP"
     }

     Custom_SetupD $opt

#   restore VXI parameters

     set-busy

     set r 1
     if {$opt != 2} then {
        if {[inform vxicontrol VXI-RestoreState] == 0 || $opt == 1} then {
            set r 0
            if {$opt == 0} then {
                inform vxirestore "click-restore-current 1"
            } else {
                inform vxirestore "click-restore-current 0"
            }
        }
     } else {
        if {[inform vxicontrol VXI-RestoreState] != 0} then {
            set r [midas-confirmation "The VXI control software has already performed a parameter restore and so this does not need to be repeated.\n\
               You may repeat the parameter restore if you wish or because you suspect that the parameters may have become corrupted.\n\
               If you choose to perform a restore parameters will be taken from the current save for each VXI crate."\
               "Perform parameter restore?"  "Skip to next step (recommended)"]
            if {$r == 0} then {inform vxirestore "click-restore-current 0"}
        } else {
            set r [midas-confirmation "The VXI control software has NOT performed a parameter restore.\n\
               Your VXI hardware may not operate correctly unless this is done.\n\
               If you choose to perform a restore parameters will be taken from the current save for each VXI crate."\
               "Perform parameter restore? (recommended)"  "Skip to next step"]
            if {$r == 0} then {inform vxirestore "click-restore-current 0"}
        }
     }
     if {$r == 0} then {inform  vxirestore destroy  .vxirestore.info}

     if {[lsearch [inform bf inquire tasklist] "vre #"] >= 0} then {
#    reload the VRE firmware which may have been changed
         if {$r == 0} then {inform vre vre-reloadDSP $VXIserver}
     }
    
     if {[inform vxicontrol VXI-RestoreState] == 0} then {
        midas-warning "VXI parameter restore has not been successful\nYou may need to correct this and retry SETUP"
     }

     clear-busy
   }

     Custom_PostSetup $opt

    if {$histPresent != 0} then {setup_histograms}

#    update display
    click-redisplay

    if {$opt == 2} then {
        midas-report "MIDAS Data Acquisition System SETUP and ready to GO at [date]"
    }

    insert-log "MIDAS Data Acquisition System SETUP and ready to GO at [date]"
    set-footer "MIDAS DA System SETUP and ready to GO at [date]" 
}

proc setup_histograms {} {
    global RDOUThdwre

#    create and enable histograms

     set-footer "Setting up histogramming"
     set-busy
     unmap_spectra
     delete_spectra
     if {$RDOUThdwre != "VME"} then {ClearConfig}
     create_spectra
     clear-busy
     clear-footer
}

proc click-vxipause {opt} {
        switch $opt {
          1  {inform vxicontrol "Stop-VXI VXI"}
          0  {inform vxicontrol "Go-VXI  VXI"}
        }
    redisplay-vxi
    update_button_states
}

proc map_spectra {} {

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

   execute-command 5 "Mapping spectra"
}

proc unmap_spectra {} {

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

   execute-command 8 "Unmapping spectra"
}

proc map_spectrum {s} {

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

   execute-command 10 "Mapping spectrum $s" "$s 0 0 0 0"
}

proc unmap_spectrum {s} {

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

   execute-command 11 "Unmapping spectrum $s" $s
}

proc ClearConfig {} {

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

   execute-command 12 "Clear Configuration"
}


#    the following procedure is a default which is useful for VME data sources
#    the procedure may be defined by application specific code
proc DefineConfig {s} {

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

#    format of module configuration record is  type  module_number  VME_address
#    where type = 9418 (S9418)
#                 0 (Acquisition control module)
#                 767 (CAEN V767 TDC module)
#                 890 (CAEN V890 TDC module)
#                 785 (CAEN V785 ADC module)

   write-register EXEC.Parameter $s
   write-register EXEC.Action 13
   write-register EXEC.Sig1 0
   wait_for_completion "Define Configuration"
}

#    this is a dummy procedure
proc define_VME_addresses {} {}

proc define_s9418_config {} {
    global VMEserver
    global S9418_Base

   set maxmodule [inform vmecontrol inquire s9418count]
   if {$maxmodule > 0} then {DefineConfig "9418 0 [format "0x%x" $S9418_Base]"}

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {eg "(register :name '/$VMEserver/s9418#$i.Disable'  ?object)" } m]
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to locate register s9418#$i.Disable"
          clear-footer
          error $m
      }
      DefineConfig "9418 $i [string range [first $m] 2 end]"
   }
}

proc define_v767_config {} {
    global VMEserver
    global V767_Base

   set maxmodule [inform vmecontrol inquire v767count]
   if {$maxmodule > 0} then {DefineConfig "767 0 [format "0x%x" $V767_Base]"}

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {eg "(register :name '/$VMEserver/v767#$i.Output_Buffer'  ?object)" } m]
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to locate register v767#$i.Output_Buffer"
          clear-footer
          error $m
      }
      DefineConfig "767 $i [string range [first $m] 2 end]"
   }
}

proc define_v890_config {} {
   global VMEserver
   global V890_Base

   set maxmodule [inform vmecontrol inquire v890count]
   if {$maxmodule > 0} then {DefineConfig "890 0 [format "0x%x" $V890_Base]"}

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {eg "(register :name '/$VMEserver/v890#$i.Output_Buffer'  ?object)" } m]
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to locate register v767#$i.Output_Buffer"
          clear-footer
          error $m
      }
      DefineConfig "890 $i [string range [first $m] 2 end]"
   }
}

proc define_v785_config {} {
   global VMEserver
    global V785_Base

   set maxmodule [inform vmecontrol inquire v785count]
   if {$maxmodule > 0} then {DefineConfig "785 0 [format "0x%x" $V785_Base]"}

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {eg "(register :name '/$VMEserver/v785#$i.Output_Buffer'  ?object)" } m]
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to locate register v767#$i.Output_Buffer"
          clear-footer
          error $m
      }
      DefineConfig "785 $i [string range [first $m] 2 end]"
   }
}

proc define_sac_config {} {
   global VMEserver

      set maxmodule [inform vmecontrol inquire saccount]
      if {$maxmodule != 0} {

          set z [catch {eg "(register :name '/$VMEserver/sac#1.STR'  ?object)" } m]
          if {$z!=0} then {
              display-eg-error-report self $m "Attempting to locate register sac#1.STR"
              clear-footer
              error $m
          }
          DefineConfig "0 0 [string range [first $m] 2 end]"
      }
}

proc do_v767_setup {} {
    global Options

   set maxmodule [inform vmecontrol inquire v767count]
   if {[string length $maxmodule] > 2} {set maxmodule 0}

   if {$maxmodule == 0} {return}
   
   starttask v767

   for {set i 1} {$i <= $maxmodule} {incr i} {

       inform v767 click-select-module $i
        
#    set window width
       set rq $Options(v767.windowwidth)
       for {set Tries 0} {$Tries < 10} {incr Tries 1} {
           inform v767 do_set_opcode 0x3000 $rq
           after 500
           set vl [inform v767 do_read_opcode 0x3100]
           if {$rq == $vl} {break}
           insert-log "Error setting V767#$i Window Width: requested $rq; set $vl"
       }

       update idletasks
       
#    set window offset
       set rq $Options(v767.windowoffset)
       for {set Tries 0} {$Tries < 10} {incr Tries 1} {
           inform v767 do_set_opcode 0x3200 $rq
           after 500
           set vl [inform v767 do_read_opcode 0x3300]
           if {$rq == $vl} {break}
           insert-log "Error setting V767#$i Window Offset: requested $rq; set $vl"
       }

       update idletasks
       
#    set acquisition mode 
       set rq $Options(v767.acqmode)
       for {set Tries 0} {$Tries < 10} {incr Tries 1} {
           inform v767 do_cmd_opcode 0x1[set rq]00
           after 500
           set vl [inform v767 do_read_opcode 0x1400]
           if {$rq == $vl} {break}
           insert-log "Error setting V767#$i Acquisition Mode: requested $rq; set $vl"
       }

#    data fifo flush - module clear does not work!!
       for {set Offset 0} {$Offset < 2048} {incr Offset 1} {
          set word [inform v767 do_read_register Output_Word]
          if {[expr $word >> 21 & 3] == 3} {break}    ;#  end of data 
       }
   }
}

proc do_v890_setup {} {
    global Options

   set maxmodule [inform vmecontrol inquire v890count]
   if {[string length $maxmodule] > 2} {set maxmodule 0}

   if {$maxmodule == 0} {return}
   
   starttask v890

   for {set i 1} {$i <= $maxmodule} {incr i} {

       inform v890 click-select-module $i
               
#    acquisition mode:
#      set trigger matching
       inform v890 do_AcqMode_opcode OPT00

#    trigger options:
#      set window width 
#      set window offset 
       inform v890 do_Trig_opcode OPT10 $Options(v890.windowwidth)
       inform v890 do_Trig_opcode OPT11 $Options(v890.windowoffset)

#      set extra search margin 0
#       set reject margin 0
       inform v890 do_Trig_opcode OPT12 0
       inform v890 do_Trig_opcode OPT13 0

#     enable subtraction of trigger time
       inform v890 do_Trig_opcode OPT14 0

#    edge detection
#      set edge detection  only leading
#      set LSB 800ps
       inform v890 do_Edge_opcode OPT22 1
       inform v890 do_edge_opcode OPT24 0

#    readout 
#    disable TDC header & EOB
#    max hits 128
       inform v890 do_Readout_opcode OPT31 0
       inform v890 do_Readout_opcode OPT33 8
   }
}

proc PrintConfig {} {

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

   execute-command 4 "Print Configuration" 0 2
}

proc spectra-names {} {
    global SpectrumServer

    set z [catch {eg "(spectrum :path '/$SpectrumServer' ?names)"} m]
    if {$z!=0} then {
       midas-warning "Unable to obtain spectrum names from $SpectrumServer: -  $m"
       clear-footer
       set m ""
    }
    return $m
}

#    procedure to be supplied by application specific code
proc create_spectra {} {}

proc delete_spectra {} {
   global SpectrumServer SpectrumserverList

   set-footer "Deleting spectra"

   foreach server $SpectrumserverList {
       set SpectrumServer $server

       set spectra [spectra-names]
       foreach item $spectra {
           set name [second $item]
           set z [catch {eg "(spectrum :path '/$SpectrumServer'  :name '$name' !delete)" } m]
       }
   }
}

proc create_s9418_spectra {} {
    global SpectrumServer S9418_Base
    global Options

   set maxmodule [inform vmecontrol inquire s9418count]
   set maxadc 32

   for {set i 1} {$i <= $maxmodule} {incr i} {

    set-footer "creating spectra for module s9418#$i"

    for {set j 0} {$j < $maxadc} {incr j} {

      set spectrumname [SpectrumName s9418#$i.adc$j]
      set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $Options(s9418.channels) :name '$spectrumname' !new)" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
      if {$z!=0 && $m==0x30004} then {set z 0}
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to create spectrum s9418#$i.adc$j"
          clear-footer
          error $m
      } else {
          set group [expr $S9418_Base - 1 + $i]
          map_spectrum  "$spectrumname $group $j $Options(s9418.offset) $Options(s9418.shift)"
      }
    }
   }
}

proc create_V785_spectra {} {
    global SpectrumServer V785_Base
    global Options

   set maxmodule [inform vmecontrol inquire v785count]
   set maxadc 32

   for {set i 1} {$i <= $maxmodule} {incr i} {

    set-footer "creating spectra for module v785#$i"

    for {set j 0} {$j < $maxadc} {incr j} {

      set spectrumname [SpectrumName v785#$i.adc$j]
      set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $Options(v785.channels) :name '$spectrumname' !new)" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
      if {$z!=0 && $m==0x30004} then {set z 0}
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to create spectrum  v785#$i.adc$j"
          clear-footer
          error $m
      } else {
          set group [expr $V785_Base - 1 + $i]
          map_spectrum  "$spectrumname $group $j $Options(v785.offset) $Options(v785.shift)"
      }
    }
   }
}

proc create_v767_spectra {} {
    global SpectrumServer V767_Base
    global Options

   set maxmodule [inform vmecontrol inquire v767count]
   set maxadc 128

   for {set i 1} {$i <= $maxmodule} {incr i} {

    set-footer "creating spectra for module v767#$i"

    for {set j 0} {$j < $maxadc} {incr j} {

      set spectrumname [SpectrumName v767#$i.tdc$j]
      set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $Options(v767.channels) :name '$spectrumname' !new)" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
      if {$z!=0 && $m==0x30004} then {set z 0}
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to create spectrum v767#$i.tdc$j"
          clear-footer
          error $m
      } else {
         if {$j < 64} then {
             set group [expr $V767_Base + (($i - 1) * 2)]
             set item $j
         } else {
             set group [expr $V767_Base + (($i - 1) * 2) + 1]
             set item [expr $j - 64]
         }
          map_spectrum  "$spectrumname $group $item $Options(v767.offset) $Options(v767.shift) "
      }
    }
   }
}

proc create_v890_spectra {} {
    global SpectrumServer V890_Base
    global Options

   set maxmodule [inform vmecontrol inquire v890count]
   set maxadc 128

   for {set i 1} {$i <= $maxmodule} {incr i} {

    set-footer "creating spectra for module v890#$i"

    for {set j 0} {$j < $maxadc} {incr j} {

      set spectrumname [SpectrumName v890#$i.tdc$j]
      set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $Options(v890.channels) :name '$spectrumname' !new)" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
      if {$z!=0 && $m==0x30004} then {set z 0}
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to create spectrum v890#$i.tdc$j"
          clear-footer
          error $m
      } else {
         if {$j < 64} then {
             set group [expr $V890_Base + (($i - 1) * 2)]
             set item $j
         } else {
             set group [expr $V890_Base + (($i - 1) * 2) + 1]
             set item [expr $j - 64]
         }
          map_spectrum  "$spectrumname $group $item $Options(v890.offset) $Options(v890.shift)"
      }
    }
   }
}

if {![info exists XlatePres]}       {set XlatePres 0}

proc SpectrumName {n} {Give_Xlate $n}

proc Make_Xlate {n} {
   global env Xlate XlateR XlatePres

   if {[info exists Xlate]}  {unset Xlate}
   if {[info exists XlateR]} {unset XlateR}
   set XlatePres 0

     set z [catch {set directory [file join $env(EXPERIMENTBASE) Histconfigs]} m]
     if {$z != 0} then {
        midas-warning "$m\nYou should probably Join an experiment!"
        close-frame
        return
     }

     if {![file exists $directory]} then {
        set z [catch {:file mkdir $directory} m]
        if {$z!=0} then {midas-warning "Cannot create directory $directory\n $m"}
     }

   #  read name translation file

   set z [catch {open [file join $directory [set n]_names] r} f]
   if {$z != 0} then {
       set-footer "Name translation file [file join $directory [set n]_names] does not exist"
       set Names {}
   } else {
       clear-footer ""
       set Names [split [read $f] \n]
       close $f
   }
   
   foreach item $Names {
       if {$item == ""} {continue}
       if {[third $item] == 0} {continue}
       if {[string range [first $item] 0 0] == "#"} continue
       set Xlate([first $item])  [second $item]
       set XlateR([second $item])  [first $item]
       set XlatePres 1
   }
}

proc Give_Xlate {n} {Do_Xlate $n}
proc Give_XlateR {n} {Do_XlateR $n}

proc Do_Xlate {n} {
   global XlatePres Xlate

   if {$XlatePres == 0} {return $n}
   if {[info exists Xlate($n)]} {return $Xlate($n)} else {return $n}
}

proc Do_XlateR {n} {
   global XlatePres XlateR

   if {$XlatePres == 0} {return $n}
   if {[info exists XlateR($n)]} {return $XlateR($n)} else {return $n}
}

proc Show_Xlate {} {
    global XlatePres Xlate XlateR
    global _information_font

    if {$XlatePres == 0} {return}

    set contents ""

    set l1 [lsort -dictionary [array names Xlate]]
    set l2 [lsort -dictionary [array names XlateR]]

    set i 0
    foreach name $l1 {
        set n1 [lindex $l1 $i]
        append contents [format "%24s %24s\n" $n1 $Xlate($n1)]
        incr i
    }

    append contents "\n\n"

    set i 0
    foreach name $l2 {
        set n2 [lindex $l2 $i]
        append contents [format "%24s %24s\n" $n2 $XlateR($n2)]
        incr i
    }
    
    set _information_font fixed
    midas-information "$contents"
}

proc Edit_Xlate {text}  {
    global env __editxlatedone


  :frame "[self frame-name].textedit" :label "[self frame-title]" :show-footer T  :resize F :toplevel T \
      :icon-image "@$env(ICONHOME)/default" \
      :icon-name "[self icon-title]"

    set __editxlatedone 0
  
    :panel TEXTEDITPANEL :layout T :padx 10 :pady 10
      :layout H; :row-gap 5; :col-gap 20

    :galley TEXTEDIT :rows 50 :cols 100 :font fixed
     :next-row T

    :button TEXTEDITDONE :label "Save file and finish"     :command Edit_Xlate_done
    :button TEXTEDITQUIT :label "Quit without saving file" :command Edit_Xlate_quit
    :show T

    :modify TEXTEDIT :strings "$text" 

   vwait __editxlatedone

   if {$__editxlatedone == 1}  {
       set text "[[:path TEXTEDIT].text get 1.0 end]"
   } else {
       set text ""
   }

   destroy "[self frame-name].textedit"

   return $text
}

proc Edit_Xlate_done {} {global __editxlatedone; set __editxlatedone 1}
proc Edit_Xlate_quit {} {global __editxlatedone; set __editxlatedone 2}


proc edit_xlate {}  {
   global XlatePres Xlate
   global env SpectrumServer

   if {$XlatePres == 0} then {Make_Xlate $SpectrumServer}
#   if {$XlatePres == 0} then {return}

   set contents "#  format is:  standard name (ie s9418#2.adc12)            alias  (ie strip1.E)\n"

   foreach item [array names Xlate] {
       append contents [format "%24s %24s\n" $item $Xlate($item)]
   }

    set contents [split [Edit_Xlate $contents] \n]

    if {[llength $contents] == 0} then {return}

#    data has been modified  - save to file

    set file [file join $env(EXPERIMENTBASE) Histconfigs [set SpectrumServer]_names]
    set z [catch {open $file w} f]
    if {$z != 0} then {midas-warning "Unable to write file $file\n$f"; return}

    foreach item $contents {
       if {[llength $item] == 2} then {
           puts $f "$item"
       }
    }
    close $f
    set-footer "$file updated"

#  update the arrays

    Make_Xlate $SpectrumServer
}

proc click-camac {action} {
  global CAMACEnable CAMACserver CAMACcontroller EGallow

  if {$CAMACEnable == 0} then {return}

   starttask camaccontrol

    switch $action {
      0    {set p DAQ-halt}
      1    {set p DAQ-go}
      2    {set p DAQ-reset}
    }

   set-busy

   do_inhibit_camac
 
   set-footer "sending $p to CAMAC control task"
   set z [catch {send camaccontrol $p} m]

   if {$action == 1} then {do_uninhibit_camac}

   clear-busy
   if {$m == ""} then {clear-footer} else {set-footer $m}
   redisplay-camac
}

proc  do_inhibit_camac {} {
  global CAMACserver CAMACcontroller EGallow

#    inhibit CAMAC
   set EGallow 0x10004
   if {$CAMACcontroller == "SCC"} then {
       set camacstate [EG "register :pattern '$CAMACserver/SCC#?.set' :value '0x0004'"]
   }
   if {$CAMACcontroller == "RS232CC"} then {
       set camacstate [EG "register :pattern '$CAMACserver/RS232CC#?.status' :value '0x000420'"]
   }
   if {$CAMACcontroller == "CC"} then {
       set camacstate [EG "register :pattern '$CAMACserver/CC#?.SetI' :value '0'"]
   }
   set EGallow 0xffffffff
}

proc  do_uninhibit_camac {} {
  global CAMACserver CAMACcontroller EGallow

#    uninhibit CAMAC
   set EGallow 0x10004
   if {$CAMACcontroller == "SCC"} then {
       set camacstate [EG "register :pattern '$CAMACserver/SCC#?.clear' :value '0x0004'"]
   }
   if {$CAMACcontroller == "RS232CC"} then {
       set camacstate [EG "register :pattern '$CAMACserver/RS232CC#?.status' :value '0x000400'"]
   }
   if {$CAMACcontroller == "CC"} then {
       set camacstate [EG "register :pattern '$CAMACserver/CC#?.UnSetI' :value '0'"]
   }
   set EGallow 0xffffffff
}

proc redisplay-camac {} {
   global CAMACEnable CAMACPresent CAMACserver CAMACcontroller EGallow

  if {$CAMACPresent == 0} then {return}
  if {$CAMACEnable == 0} then {:modify CAMAC :value -1; return}

   set EGallow 0x10004
   if {$CAMACcontroller == "SCC"} then {
       set camacstate [EG "register :name '$CAMACserver/SCC#1.status' ?value"]
   }
   if {$CAMACcontroller == "RS232CC"} then {
       set camacstate [EG "register :name '$CAMACserver/RS232CC#1.status' ?value"]
   }
   if {$CAMACcontroller == "CC"} then {
       set camacstate [EG "register :name '$CAMACserver/CC#1.TestI' ?value"]
   }
   set EGallow 0xffffffff

   if {$camacstate == "0x10004"} then {:modify CAMAC :value -1; return}

   if {$CAMACcontroller != "CC"} then {
       if {[second $camacstate] != "%11"} then {:modify CAMAC :value -1; return}
   } else {
       if {$camacstate == "%00"} then {:modify CAMAC :value -1; return}
   }

   if {$CAMACcontroller == "SCC"} then {
       set stat  [expr [first $camacstate] >> 6 & 1]
   }
   if {$CAMACcontroller == "RS232CC"} then {
       set stat  [expr [first $camacstate] >> 4 & 1]
   }
   if {$CAMACcontroller == "CC"} then {
       if {$camacstate == "%11"} then {set stat 1} else {set stat 0}
   }
   if {$stat != 0} then {:modify CAMAC :value 0} else {:modify CAMAC :value 1}
}

proc click-vme {action args} {
    global VMEPresent VMEEnable

  if {$VMEPresent == 0} then {return}
  if {$VMEEnable == 0} then {:modify VME :value -1; return}

   starttask vmecontrol

    switch $action {
      0    {set p DAQ-halt}
      1    {set p DAQ-go}
      2    {set p DAQ-reset}
      3    {set p DAQ-setup}
    }

   set-footer "sending $p to VME control task"
   set-busy
   if {[llength $args] == 0} then {
       set z [catch {send vmecontrol $p} m]
   } else {
       set z [catch {send vmecontrol $p [first $args]} m]
   }
   clear-busy
   if {$m == ""} then {clear-footer} else {set-footer $m}
   redisplay-vme
   update_button_states
}
proc redisplay-vme {} {:modify VME :value -1}


proc click-vxi {action args} {
    global VXIPresent VXIEnable

  if {$VXIPresent == 0} then {return}
  if {$VXIEnable == 0} then {:modify VXI :value -1; return}

   starttask vxicontrol

    switch $action {
      0    {set p DAQ-halt}
      1    {set p DAQ-go}
      2    {set p DAQ-flush}
      3    {set p DAQ-reset}
      4    {set p DAQ-setup}
    }

   set-footer "sending $p to VXI control task"
   set-busy
   if {[llength $args] == 0} then {
       set z [catch {send vxicontrol $p} m]
   } else {
       set z [catch {send vxicontrol $p [first $args]} m]
   }
   clear-busy
   if {$m == ""} then {clear-footer} else {set-footer $m}
   redisplay-vxi
   update_button_states
}

proc redisplay-vxi {} {
   global vxistate
   global VXIEnable

  if {$VXIEnable == 0} then {return}

   set-busy
   starttask vxicontrol

   catch {set vxistate [send vxicontrol read-vxistate]}
   :modify VXI :value $vxistate

   clear-busy
}

proc click-rdout  {v} {
   global RDOUTEnable RDOUThdwre

   if {$RDOUTEnable == 0} then {return}

    set z [catch {
        if {$v==0} then {
#    Halt
              after cancel Check-DA
              execute-command 1 "Halt"
        }
        if {$v==1} then {
#    Go
              if {[read-register $RDOUThdwre.Cspectramapped] != 1} then {map_spectra}

              execute-command 2 "Go"
              after 5000 Check-DA
        }
        if {$v==2} then {
#    Setup
              after cancel Check-DA
              execute-command 3 "Setup"
        }
        if {$v==3} then {
#    Reset 
              after cancel Check-DA
              execute-command 9 "Reset"
        }
        wait_for_completion
    } m ]
    redisplay-rdout
    clear-footer
}

proc redisplay-rdout {} {
   global RDOUThdwre RDOUTEnable readoutstate
   if {$RDOUTEnable == 0} then {:modify RDOUT :value -1; return}
   set readoutstate [expr [read-register $RDOUThdwre.Sstate]-1]
   :modify RDOUT :value $readoutstate
}

proc click-tsenable {v} {
   global TSEnable
   set TSEnable $v
   :modify TAPE   :value -1
   :modify STREAM :value ""
   :modify RATE   :value ""
   :modify PERCENT :value ""
   redisplay-tapes
}

proc redisplay-tsenable {} {
   global TSEnable
   :modify TSENABLE :value $TSEnable
}

proc click-txenable  {v} {
    global RDOUThdwre RDOUTEnable txEnable TSPresent
    if {$RDOUTEnable == 0} then {set txEnable 0} else {set txEnable $v}
    if {$TSPresent == 0 || [read-register TS_Server] == ""} then {
        set txEnable 0
    } else {
        if {$RDOUTEnable != 0} then {write-register $RDOUThdwre.Ctxenable $txEnable}
    }
    redisplay-txenable
}

proc click-ebtxenable  {v} {
    global RDOUThdwre RDOUTEnable ebtxEnable EBPresent
    if {$RDOUTEnable == 0} then {set ebtxEnable 0} else {set ebtxEnable $v}
    if {$EBPresent == 0 || [read-register EB_Server] == ""} then {
        set ebtxEnable 0
    } else {
        if {$RDOUTEnable != 0} then {write-register $RDOUThdwre.Cebtxenable $ebtxEnable}
    }
    redisplay-ebtxenable
}

proc redisplay-txenable {} {
   global RDOUThdwre RDOUTEnable txEnable  TSPresent
   if {$TSPresent == 0} then {return}
   if {$RDOUTEnable == 0} then {:modify TXENABLE :value 0; return}
   set txEnable [read-register $RDOUThdwre.Ctxenable]
   :modify TXENABLE :value $txEnable
}

proc redisplay-ebtxenable {} {
   global RDOUThdwre RDOUTEnable ebtxEnable EBPresent
   if {$EBPresent == 0} then {return}
   if {$RDOUTEnable == 0} then {:modify EBTXENABLE :value 0; return}
   set ebtxEnable [read-register $RDOUThdwre.Cebtxenable]
   :modify EBTXENABLE :value $ebtxEnable
}

proc click-histenable {v} {
    global RDOUThdwre RDOUTEnable histEnable
    if {$RDOUTEnable == 0} then {set  histEnable 0} else {set histEnable $v}
    if {$RDOUTEnable != 0} then {write-register $RDOUThdwre.Chistenable $histEnable}
    redisplay-histenable
}

proc redisplay-histenable {} {
   global RDOUThdwre RDOUTEnable histEnable
   if {$RDOUTEnable == 0} then {:modify HISTENABLE :value 0; return}
   set histEnable [read-register $RDOUThdwre.Chistenable]
   :modify HISTENABLE :value $histEnable
}

proc click-camacenable {v} {
    global debug  CAMACEnable
    set CAMACEnable $v
    redisplay-xxxenable
}

proc click-vmeenable {v} {
    global debug  VMEEnable
    set VMEEnable $v
    redisplay-xxxenable
}

proc click-vxienable {v} {
    global debug  VXIEnable
    set VXIEnable $v
    redisplay-xxxenable
}

proc click-rdoutenable {v} {
    global debug  RDOUTEnable
    if {$v == 0} then {
        if {[midas-confirmation "This will disable the Data Acquisition program\nAre you sure you want to do this?"] == 0} then {
            redisplay-xxxenable
            return
        }
    }
    set RDOUTEnable $v
    if {$RDOUTEnable == 0} then {
         click-histenable 0
         click-txenable 0
         click-ebtxenable 0
    }
    redisplay-xxxenable
}

proc redisplay-xxxenable {} {
  global CAMACEnable VMEEnable VXIEnable CAMACPresent VMEPresent VXIPresent RDOUTEnable

 if {$CAMACPresent == 1} {
    :modify CAMACENABLE :value $CAMACEnable
    redisplay-camac
 }
 if {$VMEPresent == 1} {
    :modify VMEENABLE :value $VMEEnable
    redisplay-vme
 }
 if {$VXIPresent == 1} {
    :modify VXIENABLE :value $VXIEnable
    redisplay-vxi
 }
   :modify RDOUTENABLE :value $RDOUTEnable
}

proc click-trace {v} {
   global RDOUThdwre

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

   write-register $RDOUThdwre.Ctrace $v
}

proc click-zero {} {

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

   execute-command 6 "Zeroing X2VB RAM"
}

proc click-format {} {

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}
   global TestBuffer
   global EGreport

   if {$TestBuffer == ""} then {set-footer "No test buffer defined"; return}

    set EGreport_SAVE $EGreport
    set EGreport -1

    execute-command 5 "" -1

   foreach word $TestBuffer {
       execute-command 5 "" "0 $word"
   }

   execute-command 5 "Formatting X2VB RAM" 1

    set EGreport $EGreport_SAVE
}

proc click-special {a} {

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

   execute-command $a "" 0 2
}

proc click-testmode {a} {
   global RDOUThdwre

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

   if {$a == 0} then {

#    start test mode

       write-register $RDOUThdwre.TestMode 1
       write-register EXEC.Action 5
       write-register EXEC.Sig2 0
   } else {

#    stop test mode

       write-register $RDOUThdwre.TestMode 0
    }
}


proc Null_Events {vl} {
    global RDOUThdwre RDOUTEnable 
    if {$RDOUTEnable != 0} then {write-register $RDOUThdwre.Cignorenullevents $vl}
}

proc RdOut_Enable {vl} {
    global RDOUThdwre RDOUTEnable 
    if {$RDOUTEnable != 0} then {write-register $RDOUThdwre.Crdoutenable $vl}
}

if {$RDOUThdwre == "D2VB"} {

proc click-histmode {w v} {
    global RDOUTEnable RDOUThdwre HistMode
    if {$RDOUTEnable == 0} then {
        set HistMode 0
    } else {
        set HistMode $v
        write-register $RDOUThdwre.Chistmode $v
    }
    redisplay-histmode
}

proc redisplay-histmode {} {
   global RDOUThdwre RDOUTEnable HistMode
   if {$RDOUTEnable != 0} then {set HistMode [read-register $RDOUThdwre.Chistmode]}
   :modify HISTMODE :value $HistMode
}

} else {

proc click-histmode {w v} {
    global RDOUTEnable HistMode
    if {$RDOUTEnable == 0} then {set  HistMode 0} else {set HistMode $v}
    redisplay-histmode
}

proc redisplay-histmode {} {
   global HistMode
   :modify HISTMODE :value $HistMode
}

}

proc checkinstallation  {} {
   global OS VERSION env

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return 0}

   set ID [read-register EXEC.ID]
   set OS [first $ID]
   set version  [second $ID]
   set release [third $ID]

   if {$version != $VERSION} then {
       set msg " WARNING!  Possible system installation or setup error! \n\
       Require Data Acquisition program $VERSION but discovered \n\
       OS $OS; Program $version; Release $release\n\
       Do you wish to continue?"
       if {[midas-confirmation $msg] == 0} then {return 1}
   }

   set env(RTOS) $OS
   return 0
}

proc click-ID {} {

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

    set ID [read-register EXEC.ID]
    insert-log "Target OS = [first $ID]\nProgram = [second $ID]\nVersion = [third $ID]"
}

proc Check-DA {} {
   global OS RDOUThdwre Alive
   global CheckDAPeriod

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

#    this check only works if GOING

   if {$OS == "VxWorks"} then {return}

   if {[winfo ismapped .]} then {

       set state [read-register $RDOUThdwre.Sstate]
       if {$state != 2} then {return}

       set-footer "Checking Data Acqusition Program"

       set Alive [read-register $RDOUThdwre.CAlive]
       write-register $RDOUThdwre.CAlive 0

       if {$Alive == 0} then {
#        midas-warning "Warning - Check the Data Acquisition Program - It may have crashed"
             set-footer "Warning - No data being received or the DA Program has crashed"
       } else {
             set-footer "Data Acquisition running OK"
       }

       click-redisplay

#      clear-footer
   }

   if {$CheckDAPeriod > 0} then {after [expr $CheckDAPeriod*1000] Check-DA}
}

proc click-redisplay {} {
    global RISING
   set-footer "Updating display"
   catch redisplay-camac
   catch redisplay-vme
   catch redisplay-vxi
   catch redisplay-rdout
   catch redisplay-histenable
   catch redisplay-txenable
   catch redisplay-tsenable
   catch redisplay-ebtxenable
   catch redisplay-histmode
   catch redisplay-xxxenable
   catch redisplay-tapes
   catch Custom_Redisplay
if {[info exists RISING]} then {catch redisplay-mbs}
   update_button_states
   set-footer "Display Updated [date]"
}  

proc da_state {} {
  global VXIEnable VMEEnable TSEnable RDOUTEnable
  global vxistate vmestate tapestate readoutstate

#    if any one of the controlled subsystems is in the GO state then the
#    overall state is GO button

  set state 0

  if {$VXIEnable == 1 && $vxistate == 1}     then {set state 1}
  if {$VMEEnable == 1 && $vmestate == 1}     then {set state 1}
  if {$TSEnable == 1 && $tapestate == 1}     then {set state 1}
  if {$RDOUTEnable == 1 && $readoutstate == 1}     then {set state 1}

  return $state
}

proc update_button_states {} {
  global VXIEnable VMEEnable TSEnable RDOUTEnable
  global vxistate vmestate tapestate readoutstate

#    if any one of the controlled subsystems is in the GO state then the
#    overall GO button should be disabled

  if {$VXIEnable == 1 && $vxistate == 1}     then {disable_go; return}
  if {$VMEEnable == 1 && $vmestate == 1}     then {disable_go; return}
  if {$TSEnable == 1 && $tapestate == 2}     then {disable_go; return}
  if {$RDOUTEnable == 1 && $readoutstate == 1}     then {disable_go; return}

  :modify DA-GO :colour green :inactive F
}

proc disable_go {} {:modify DA-GO :colour white :inactive T}
  
proc click arg {
    global debug actionlist ScalerType RDOUThdwre
    if {$debug} then {puts stderr "click with argument \{$arg\}"}
    set f [lindex $arg 0]
    set c [lindex $arg 1]
    set w [lindex $arg 2]
    set v [lindex $arg 3]
    set i [lindex $arg 4]

    if {$c==":quit"} then {return [click-quit]}
    switch $w  {
                DA-STOP  {click-da 0; click-redisplay}
                DA-GO    {click-da 1; click-redisplay}

                CAMAC {click-camac $v}
                CAMACENABLE {click-camacenable $v}
                VME   {click-vme $v}
                VMEENABLE {click-vmeenable $v}
                VXI   {click-vxi $v}
                VXIENABLE {click-vxienable $v}
                RDOUT   {click-rdout $v}
                RDOUTENABLE {click-rdoutenable $v}
                HISTENABLE {click-histenable $v}
                TXENABLE {click-txenable $v}
                EBTXENABLE {click-ebtxenable $v}
                TSENABLE {click-tsenable $v}
                TAPE  {click-tapes $v}

                FORMATOPTION {write-register Format_Option [expr $v+1]; update-test-frame}
                TSXFER       {write-register Xfer_Option [expr $v+1]; update-test-frame}
                EBXFER       {write-register EBXfer_Option [expr $v+1]; update-test-frame}
                TDCMODE      {write-register TDC.Mode $v; update-test-frame}
                TDCOPTION    {write-register TDC.Option $v; update-test-frame}

                ACTIONS  {
                    set action [lindex $actionlist $i]
                    set r [midas-confirmation "You are about to execute the action \"[first $action]\"\nAre you sure?"]
                    if {$r == 1} then {eval [second $action]}
                }

                MONITOR {
                    switch $v {
                       Statistics {inform stats start}
                       Monitoring {inform monitor start}
                    }
                }

                SPECTRA {
                    switch $v {
                        "Spectrum Browser"  {inform sb start}
                        "Spectrum Viewer"   {inform sd start}
                    }
                }

                SCALERS {
                    switch $v {
                        Show  {inform $ScalerType start}
                        Clear {inform $ScalerType click-clear-all}
                    }
                }

        REDISPLAY {click-redisplay}
        STATISTICS {inform stats start}

        default {puts stdout $arg}
    }
}

set Retry 0
proc click-Retry {v} {global Retry; set Retry $v}

proc check_for_experiment {} {
    global env Retry

    set z [catch {set env(EXPERIMENTDIR)}]
    if {$z == 1 || ![file isdirectory $env(EXPERIMENTDIR)]} then {

        :frame [self frame-name] :label "[self frame-title]" \
           :icon-image "@$env(ICONHOME)/default" \
           :icon-name "[self icon-title]" :resize F

        :panel P :layout T :padx 10 :pady 10
        :layout H; :col-gap 10; :row-gap 10

        :message M  :bold T :justify center :label "\
You are not connected to a useable experiment\n\
It is essential that you are connected to an experiment before starting the Experiment Control\n\
Please correct this and then click on Continue."

        :next-row T

        :button CONTINUE :label Continue :w 12 :command "click-Retry 0"
        :button ABORT    :label Abort    :w 12 :command "click-Retry 1"

        :show T

        tkwait variable Retry

         destroy-frame

        if {$Retry == 0} then {return 1} else {return -1}
    } else {return 0}
}

proc start args {
   global started CAMACEnable VMEEnable VXIEnable TitrisPresent

   for {set i 0} {$i < 100} {incr i} {
       set rc [check_for_experiment]
       if {$rc < 0}  return
       if {$rc == 0} break
   }

   if {$started == 0} then {make-frame} else {open-frame}
   set started 1
if {$CAMACEnable == 1} then {
   starttask camaccontrol
   starttask camacsaverestore
}
if {$VMEEnable == 1} then {
   starttask vmecontrol
   starttask vmesaverestore
   if {[info exists TitrisPresent]} {starttask titris}
}
if {$VXIEnable == 1} then {
   starttask vxicontrol
   starttask vxirestore
}

   Set_Options
   Custom_Start
 
   click-redisplay
}

proc click-quit args {close-frame}

proc finish args {destroy-frame}

proc make-frame {} {
  global env RDOUThdwre actionlist
  global VERSION CAMACPresent VMEPresent VXIPresent X2VBPresent
  global HistMode
  global CAMACEnable VMEEnable VXIEnable 
  global RDOUTEnable TSPresent EBPresent
  global RISING UCL


  :frame [self frame-name] :label "[self frame-title]" :show-footer T \
      :icon-image "@$env(ICONHOME)/default" \
      :icon-name "[self icon-title]" :resize F

   :container P1 :layout T
    :layout H; :row-gap 10; :col-gap 10

   :panel P1A :layout L :padx 10 :pady 10
    :layout H; :row-gap 10; :col-gap 10

if {$CAMACPresent == 1} {
      :choice CAMAC :label Camac: :strings [list Stop Go] :valuex 14c :value -1
      :checkbox CAMACENABLE :label "" :value $CAMACEnable
      :next-row T
      lappend actionlist "\"CAMAC Reset\" \"click-camac 2\""
   if {$X2VBPresent == 1} {
      lappend actionlist "\"Zero X2VB RAM\" \"click-zero\""
      lappend actionlist "\"Format X2VB RAM\" \"click-format\""
      lappend actionlist "\"Force X2VB Read Out\" \"RdOut_Enable 1\""
      lappend actionlist "\"Normal X2VB Read Out\" \"RdOut_Enable 0\""
   }

}
if {$VMEPresent == 1} {
      set label "VME:"
      if {$VERSION == "PRISMA"} then {set label "CLARA (VME)"}
      :choice VME :label $label :strings [list Stop Go] :valuex 14c :value -1
      :checkbox VMEENABLE :label "" :value $VMEEnable
      :next-row T
      lappend actionlist "\"VME Reset\" \"click-vme 2\""
}
if {$VXIPresent == 1} {
      set label "VXI:"
      if {$VERSION == "PRISMA"} then {set label "CLARA (VXI)"}
      :choice VXI :label $label :strings [list Stop Go] :valuex 14c :value -1
      :checkbox VXIENABLE :label "" :value $VXIEnable
      :next-row T
      lappend actionlist "\"Pause VXI\" \"click-vxipause 1\""     
      lappend actionlist "\"Resume VXI\" \"click-vxipause 0\""
      lappend actionlist "\"VXI Reset\" \"click-vxi 3\""
      lappend actionlist "\"VXI Setup\" \"click-vxi 4\""
      lappend actionlist "\"Ignore Null Events\" \"Null_Events 1\""
      lappend actionlist "\"Keep Null Events\" \"Null_Events 0\""
   if {$X2VBPresent == 1} {
      lappend actionlist "\"Zero X2VB RAM\" \"click-zero\""
      lappend actionlist "\"Format X2VB RAM\" \"click-format\""
      lappend actionlist "\"Force X2VB Read Out\" \"RdOut_Enable 1\""
      lappend actionlist "\"Normal X2VB Read Out\" \"RdOut_Enable 0\""
   }
}

if {$RDOUThdwre != "VME"} then {
      set label "[set RDOUThdwre]"
      if {$VERSION == "PRISMA"} then {set label "CLARA readout"}
      :choice RDOUT :label $label :strings [list Stop Go] :valuex 14c :value -1
      lappend actionlist "\"[set RDOUThdwre] Setup\" \"click-rdout 2\""
      lappend actionlist "\"[set RDOUThdwre] Reset\" \"click-rdout 3\""
} else {
      :choice RDOUT :label Readout: :strings [list Stop Go] :valuex 14c :value -1
      lappend actionlist "\"Readout Setup\" \"click-rdout 2\""
      lappend actionlist "\"Readout Reset\" \"click-rdout 3\""
}

      :checkbox RDOUTENABLE :label "" :value $RDOUTEnable

if {$UCL == 1} then {
      :row-gap 20; :next-row T
      :number RUNTIME :label "Run Time (s)" :w 6 :min 0 :max 500 :command do-runtime
}

   :panel P1B :layout L :padx 10 :pady 10
    :layout H; :row-gap 10; :col-gap 10

      :button  DA-STOP  :label  STOP  :w 8 :h 3 :colour red
      :hskip 30
      :button  DA-GO    :label  GO    :w 8 :h 3 :colour green
      :next-row T
      :button DA-SETUP  :label SETUP  :w 26 :h 2 :colour yellow :command "click-setup 0"

  :container end

   :panel P2 :layout T :padx 10 :pady 10
    :layout H; :row-gap 10; :col-gap 10

if {$VERSION == "PRISMA"} then {
      global PRISMAEnable
      :checkbox TXENABLE         :label "CLARA => Merge Enabled"  :value 0  :valuex 25c
      :next-row T
      :choice PRISMA :label "PRISMA" :strings [list Stop Go] :valuex 14c :value -1  :command click-prisma
      :checkbox PRISMAENABLE :label "" :value $PRISMAEnable  :command click-prismaenable
      :message PWARN :label "Status not checked" :bold T
      :button PRISMAUPDATE :label Update :command update-prisma
      :button PRISMARESET  :label Reset  :command reset-prisma
      :next-row T
      lappend actionlist "\"PRISMA Setup\" \"click-prisma 2\""
      lappend actionlist "\"PRISMA Reset\" \"click-prisma 3\""
}
      :col-gap 20

      :checkbox HISTENABLE :label "Histogramming Enabled"    :value 0  :valuex 20c
      if {$VERSION != "GREAT"} then {
         if {$VERSION == "Megha"} {set HistChoices [list None E T E&T]}
         if {$VERSION != "Megha"} {set HistChoices [list None All]}
         if {$VXIPresent == 1} {set HistChoices [list Event Raw]}
         :choice HISTMODE :label Histogram :strings $HistChoices :command click-histmode :value $HistMode
      }
      if {$VERSION == "GREAT" || $VXIPresent == 1} then {
         :button HIST :label "Histogram Setup" :command "send shist start"
      }
      
      if {$VERSION == "Megha" || $VERSION == "Charissa" || $VERSION == "TUDA"} {
         :menubutton SCALERS :label "Scalers" :strings [list Show Clear]
      }

      :next-row T
      :col-gap 10

if {[info exists RISING]} then {
      :text TRIGRATE    :label "Master Trigger Rate (/sec)" :w 6 :deaf T :valuex 22c
      :text EVENTRATE   :label "Accepted Event Rate (/sec)" :w 6 :deaf T :valuex 23c
      :next-row T

       :text TSSERVER      :label "MBS Server"  :w 8 :command do_tsserver
       :text TSPORT        :label "Port"        :w 5  :command do_tsport
       :button TSDEFINE    :label "Setup Connection"  :command do_tsdefine
       :button TSUNDEFINE  :label "End Connection" :command do_tsundefine

      :next-row T
      :checkbox TXACTIVE :label "MBS Connected" :deaf T
      :checkbox TXENABLE :label "MBS Transfer Enabled" :value 0
      :text TXRATE :label "Data Rate (Kbytes/sec)" :w 6 :deaf T
} else {

if {$VERSION != "PRISMA"} {
if {$TSPresent != 0} {
      :checkbox TXENABLE   :label "TS Transfer Enabled"  :value 0  :valuex 20c
}
if {$EBPresent != 0} {
      :checkbox EBTXENABLE :label "EB Transfer Enabled"  :value 0  :valuex 20c
}

if {$TSPresent != 0 || $EBPresent != 0} then {:next-row T}
}

if {$TSPresent} then {
     :choice TAPE :label Tapes: :strings [list Stop Go] :valuex 14c
     :checkbox TSENABLE   :label "Tape Server Enabled"  :value 0

      :button TAPECONTROL :label "Tape Control" :command "inform tape start"
      :next-row T
      :text STREAM  :label "Tapes in Use" :w 30 :deaf T
      :text RUN     :label "Run Number" :w 8 :deaf T  :value "unknown" 
      :next-row T
      :text RATE    :label "Tape Rate (Kbytes/sec)" :w 6 :deaf T
      :text PERCENT :label "Tape Used (%)" :w 6 :deaf T
}

}


if {$VERSION == "TAS"} {
      :next-row T
      :button HM413 :label "Update HM413 Histograms" :command click-HM413ReadOut
}

   :panel P3 :layout B :padx 10 :pady 10 :after FOOTER
    :layout H; :row-gap 10; :col-gap 5
      :button REDISPLAY    :label Redisplay
      :menubutton MONITOR      :label Monitoring  :strings [list Statistics Monitoring]
      :menubutton SPECTRA      :label Spectra     :strings [list "Spectrum Browser"  "Spectrum Viewer"]
      :button REGISTERS        :label "Setup Registers" :command make-registers
      set menu {}
      foreach item $actionlist {lappend menu [first $item]}
      :menubutton ACTIONS :label "Advanced"  :strings $menu

   :show T

}

proc make-test-frame {} {

global actionlist RDOUThdwre VERSION
global TSPresent EBPresent
global RISING

  :frame [self frame-name].adv :label "System Configuration, Test and Debug Only" :show-footer T :resize F

    :panel ADVP1 :layout T :padx 10 :pady 10
      :layout H; :row-gap 5; :col-gap 5

        set i 0
        foreach item $actionlist {
            :button A$i :label "[first $item]" :command "[second $item]" :w 24
            incr i
            if {[expr ($i/4)*4] == $i} {:next-row T}
        }

        if {$VERSION == "GREAT"} then {
            set item "\"VME SYSRESET\" \"inform SHARC do-sysreset\""
            :button A$i :label "[first $item]" :command "[second $item]" :w 24
            incr i
            if {[expr ($i/4)*4] == $i} {:next-row T}
        }

     :next-row T

if {$RDOUThdwre == "D2VB" || $RDOUThdwre == "F2VB"} then {

    :message M1 :label "Test-data generator task options" :bold T
     :next-row T
       :col-gap 30

       :slider DELAYTICKS   :label "Delay (msecs)"  :min 1 :max 5000  :command do_pgmoption
       :slider POLLTICKS    :label "Buffers/Tick"   :min 1 :max 32    :command do_pgmoption
} else {

    :message M1 :label "program options" :bold T
     :next-row T
       :col-gap 30

       :slider POLLTICKS    :label "Polling Delay"   :min 1 :max 500000  :command do_pgmoption
}

if {$RDOUThdwre == "D2VB"} then {

    :next-row T
    :message M2 :label "Data Acquisition Program Options" :bold T

      :next-row T
      :checkbox DEBUGMODE1 :label "Debug Mode 1" :command do_pgmoption
      :checkbox DEBUGMODE2 :label "Debug Mode 2" :command do_pgmoption
      :checkbox TIMEFILTER :label "Time Filter" :command do_pgmoption
}

if {$VERSION == "MIDAS"} then {
      :choice-stack TDCMODE   :label "TDC Mode"       :strings [list default normal "common stop" "common start"]
      :choice-stack TDCOPTION :label "TDC Hit Option" :strings [list default first last all]
      :next-row T
}

if {![info exists RISING]} then {

    :choice-stack FORMATOPTION  :label "Format Option" :strings [list GANIL GSI MIDAS RAW]

    if {$VERSION == "GREAT"} then {
        :checkbox PILEUPRATE :label "Include Pileup in Stat/Rate" :command do_pileuprate
    }

    :next-row T
    :message M3 :label "Data Destinations" :bold T

    if {$TSPresent}  then  {
     :next-row T
       :col-gap 10
       :text TSSERVER      :label "Tape Server" :w 12 :valuex 12c :command do_tsserver
       :text TSPORT        :label "Port"        :w 8  :command do_tsport
       :button TSDEFINE    :label "Setup Connection"  :command do_tsdefine
       :button TSUNDEFINE  :label "End Connection" :command do_tsundefine
       :choice-stack TSXFER  :label "Transfer Option" :strings [list 1 2 MIDAS GSI GANIL XDAQ]
    }

    if {$EBPresent}  then  {
     :next-row T
       :col-gap 10
       :text EBSERVER      :label "Event Builder" :w 12 :valuex 12c :command do_ebserver
       :text EBPORT        :label "Port"          :w 8  :command do_ebport
       :button EBDEFINE    :label "Setup Connection"  :command do_ebdefine
       :button EBUNDEFINE  :label "Cancel Connection" :command do_ebundefine
       :choice-stack EBXFER  :label "Transfer Option" :strings [list 1 2 MIDAS GSI GANIL XDAQ]
    }
}

    :next-row T
       :button UPDATE :command update-test-frame

  :show T

   make-registers
    update-test-frame
}

proc update-test-frame {} {
   global VERSION RDOUThdwre TSPresent EBPresent
   global RISING

    if {$RDOUThdwre == "D2VB" || $RDOUThdwre == "F2VB"} then {

       :modify DELAYTICKS  :value [read-register $RDOUThdwre.DelayTicks]
       :modify POLLTICKS   :value [read-register $RDOUThdwre.PollTicks]
    } else {

       :modify POLLTICKS   :value [read-register $RDOUThdwre.PollTicks]
    }

if {$RDOUThdwre == "D2VB"} then {
      :next-row T
      :modify DEBUGMODE1  :value [read-register $RDOUThdwre.DebugMode1]
      :modify DEBUGMODE2  :value [read-register $RDOUThdwre.DebugMode2]
      :modify TIMEFILTER  :value [read-register TimeFilter]
}

if {$VERSION == "MIDAS"} then {
      :modify TDCMODE   :value [read-register TDC.Mode]
      :modify TDCOPTION :value [read-register TDC.Option]
}

if {![info exists RISING]} then {

    :modify FORMATOPTION :value [expr [read-register Format_Option]-1]

    if {$TSPresent}  then  {
       :modify TSSERVER    :value [read-register TS_Server]
       :modify TSPORT      :value [read-register TS_Port]
       :modify TSXFER      :value [expr [read-register Xfer_Option]-1]
    }

    if {$EBPresent}  then  {
       :modify EBSERVER    :value [read-register EB_Server]
       :modify EBPORT      :value [read-register EB_Port]
       :modify EBXFER      :value [expr [read-register EBXfer_Option]-1]
    }
}

}

proc do_pgmoption {w v} {
    global RDOUThdwre RDOUTEnable
    if {$RDOUTEnable == 0} then {return}
    switch $w {
      DELAYTICKS  {write-register $RDOUThdwre.DelayTicks $v}
      POLLTICKS   {write-register $RDOUThdwre.PollTicks $v}
      DEBUGMODE1  {write-register $RDOUThdwre.DebugMode1 $v}
      DEBUGMODE2  {write-register $RDOUThdwre.DebugMode2 $v}
      TIMEFILTER  {write-register TimeFilter $v}
    }
}

proc do_tsserver {w s}  {write-register TS_Server $s}
proc do_tsport   {w v}  {write-register TS_Port $v}
proc do_tsdefine {}     {click-special 3}
proc do_tsundefine {}   {click-special 1}

proc do_ebserver {w s}  {write-register EB_Server $s}
proc do_ebport   {w v}  {write-register EB_Port $v}
proc do_ebdefine {}     {click-special 6}
proc do_ebundefine {}   {click-special 2}

proc do_clearstats {} {execute-command 7 "Clear Statistics"}

if {$VERSION == "GREAT"} then {
proc do_pileuprate {w v}  {global RDOUThdwre; write-register $RDOUThdwre.CPileupRate $v}
proc Poll_Ticks {v}  {do_pgmoption POLLTICKS $v}
}

#    The Options are experiment specific and normally used by SYS
#    However the same code as for the session preferences is used which allows for wider use in the future.
#    In this event these procedures may be moved to common.tcl

proc get_Option_file {} {
    global env

#    look for the Option file 
    set pd $env(EXPERIMENTDIR)
    if {![file exists $pd]} then {
         insert-log "$pd does not exist - Join an experiment!"
         return {}
    }
    if {![file isdirectory $pd]} then {
         insert-log "$pwd is not useable - it is not a directory"
         return {}
    }
    set pf [file join $pd MidasOptions]
    set z [catch {set f [open $pf r]} m]
    if {$z != 0} then {
        set z [catch {set f [open $pf w]} m]
        if {$z != 0} then {
            insert-log "Unable to access $pf - $m"
            return 1
        }
        close $f
        return {}
    }

#    and read it
    set lines [split [read $f] "\n"]
    close $f

    return $lines
}

proc put_Option_file {lines} {
   global env

#    look for the Option file 
    set pd $env(EXPERIMENTDIR)
    if {![file exists $pd]} then {
         insert-log "$pd does not exist - Join an experiment!"
         return {}
    }
    if {![file isdirectory $pd]} then {
         insert-log "$pwd is not useable - it is not a directory"
         return {}
    }
    set pf [file join $pd MidasOptions]
    set z [catch {set f [open $pf w]} m]
    if {$z != 0} then {
        insert-log "Unable to access $pf - $m"
        return 1
    }

    foreach item $lines {
      if {$item != ""} {puts $f $item}
    }

    close $f
    return 0
}

#    save all Options for the current task
proc update_Options {} {
   global env Options

   set lines [get_Option_file]
   set key [Get_My_Name]
   set range [find-keyword $lines $key]
   if {[llength $range] > 0} then {
       set lines [lreplace $lines [first $range] [expr [second $range] + 1]]
   }

   lappend lines "## $key"
   foreach item [array names Options] {
       lappend lines "$item $Options($item)"
   }
   lappend lines "##"

   set z [put_Option_file $lines]
   return $z
}

#    load all Options for the current task
proc load_Options {} {
   global env Options

   set lines [get_Option_file]
   set key [Get_My_Name]
   set range [find-keyword $lines $key]

   if {[llength $range] > 1} then {
       set stuff [lrange $lines [expr [first $range]+1] [second $range]]
       foreach item $stuff {
           set Options([head $item]) [tail $item]
       }
   }
}

#    return task Options
proc get_Options {task} {
   global env

   set lines [get_Option_file]
   set key $task
   set range [find-keyword $lines $key]
   
   set Options {}

   if {[llength $range] > 1} then {
       set stuff [lrange $lines [expr [first $range]+1] [second $range]]
       foreach item $stuff {
           lappend Options [list [first $item] [second $item]]
       }
   } else {
       lappend Options [list Options.filename  "[file join $env(HOME) MidasOptions Options]"]
   }
   return $Options
}

